import { computed } from 'vue';

export interface EnumProps {
    enum?: string[];
    enumMapperKey?: string;
    disableEnumMapping?: boolean;
    enumMapper?: Record<string, string>;
}

const enumMap = {};

export function useEnum({ enum: enumList = [], enumMapperKey = 'default', disableEnumMapping, enumMapper = {} }: EnumProps) {
    const mappedEnum = computed(() => {
        if (!disableEnumMapping) {
            enumMapper = enumMap?.[enumMapperKey] ?? {};
        } else {
            enumList.forEach(item => {
                enumMapper[item] = item;
            });
        }
        return enumMapper;
    });
    return { mappedEnum };
}

export function setEnumMap(key: string = 'default', value: Record<string, string>) {
    enumMap[key] = value;
}
